% Script 2: cross correlations in greek stocks and networks
tau = 1;
alpha = 0.05;
K = 5;
rthresh = 0.2;
M = 100;
maxtau = 20;
dattxt = 'GRstocks';

yM = load('d:\MyFiles\Teach\TimeSeriesVolos\lab\stocks2003.dat');
[n,m]=size(yM);
rand('state',0)

iV = randperm(m);
% iV = [1:m];
yM = yM(:,iV(1:K));

% Read the names of the stocks
nameM = textread('d:\MyFiles\Teach\TimeSeriesVolos\lab\stock_names.dat','%s');
nameM = nameM(iV(1:K),:);

% If NaN replace them with interpolated values for each time series
for i=1:K
    i1V = find(isnan(yM(:,i)));
    if ~isempty(i1V)
        iokV = setdiff([1:n]',i1V);
        yM(i1V,i) = interp1(iokV,yM(iokV,i),i1V,'spline');
    end
end

% Use log returns
xM = log(yM(2:n,:))-log(yM(1:n-1,:));

% For each pair compute the correlation matrix
ccM = NaN*ones(K,K);
pccM = zeros(K,K);
if tau==0
    % The correlation matrix is symmetric
    [ccM,pccM] = corrcoef(xM);
    pccM(1:K+1:K*K) = 0;
else
    % The correlation matrix is not symmetric
    for ik=1:K-1
        for jk=ik+1:K
            [tmpM,ptmpM] = corrcoef(xM(1:end-tau,ik),xM(1+tau:end,jk));
            ccM(ik,jk) = tmpM(1,2);
            pccM(ik,jk) = ptmpM(1,2);
            [tmpM,ptmpM] = corrcoef(xM(1:end-tau,jk),xM(1+tau:end,ik));
            ccM(jk,ik) = tmpM(1,2);
            pccM(jk,ik) = ptmpM(1,2);
        end
    end
end    
tit1txt = sprintf('R_{XY}(%d)',tau);
h1 = plotnetworktitle(ccM,[],nameM,tit1txt,1);

adjccM = pccM < alpha;
tit2txt = sprintf('Adjacency parametric p(R_{XY}(%d)) < %1.2f',tau,alpha);
h2 = plotnetworktitle(adjccM,[0 1],nameM,tit2txt,2);

rthreshM = abs(ccM) > rthresh;
tit3txt = sprintf('Adjacency R_{XY}(%d) > %1.2f',tau,rthresh);
h3 = plotnetworktitle(rthreshM,[0 1],nameM,tit3txt,3);

